/** @file audioc.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.1
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef AUDIOC_CMDLINE_H
#define AUDIOC_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef AUDIOC_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define AUDIOC_CMDLINE_PARSER_PACKAGE "para_audioc"
#endif

#ifndef AUDIOC_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define AUDIOC_CMDLINE_PARSER_VERSION "0.3.1"
#endif

/** @brief Where the command line options are stored */
struct audioc_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int loglevel_arg;	/**< @brief set loglevel (0-6) (default='4').  */
  char * loglevel_orig;	/**< @brief set loglevel (0-6) original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel (0-6) help description.  */
  char * socket_arg;	/**< @brief well-known socket (default=/var/paraslash/audiod.socket.$HOSTNAME).  */
  char * socket_orig;	/**< @brief well-known socket (default=/var/paraslash/audiod.socket.$HOSTNAME) original value given at command line.  */
  const char *socket_help; /**< @brief well-known socket (default=/var/paraslash/audiod.socket.$HOSTNAME) help description.  */
  int bufsize_arg;	/**< @brief size of internal buffer (default='8192').  */
  char * bufsize_orig;	/**< @brief size of internal buffer original value given at command line.  */
  const char *bufsize_help; /**< @brief size of internal buffer help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  unsigned int socket_given ;	/**< @brief Whether socket was given.  */
  unsigned int bufsize_given ;	/**< @brief Whether bufsize was given.  */

  char **inputs ; /**< @brief unamed options (options without names) */
  unsigned inputs_num ; /**< @brief unamed options number */
} ;

/** @brief The additional parameters to pass to parser functions */
struct audioc_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure audioc_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure audioc_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *audioc_args_info_purpose;
/** @brief the usage string of the program */
extern const char *audioc_args_info_usage;
/** @brief all the lines making the help output */
extern const char *audioc_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audioc_cmdline_parser (int argc, char * const *argv,
  struct audioc_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use audioc_cmdline_parser_ext() instead
 */
int audioc_cmdline_parser2 (int argc, char * const *argv,
  struct audioc_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audioc_cmdline_parser_ext (int argc, char * const *argv,
  struct audioc_args_info *args_info,
  struct audioc_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audioc_cmdline_parser_dump(FILE *outfile,
  struct audioc_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audioc_cmdline_parser_file_save(const char *filename,
  struct audioc_args_info *args_info);

/**
 * Print the help
 */
void audioc_cmdline_parser_print_help(void);
/**
 * Print the version
 */
void audioc_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a audioc_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void audioc_cmdline_parser_params_init(struct audioc_cmdline_parser_params *params);

/**
 * Allocates dynamically a audioc_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized audioc_cmdline_parser_params structure
 */
struct audioc_cmdline_parser_params *audioc_cmdline_parser_params_create(void);

/**
 * Initializes the passed audioc_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void audioc_cmdline_parser_init (struct audioc_args_info *args_info);
/**
 * Deallocates the string fields of the audioc_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void audioc_cmdline_parser_free (struct audioc_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use audioc_cmdline_parser_config_file() instead
 */
int audioc_cmdline_parser_configfile (char * const filename,
  struct audioc_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int audioc_cmdline_parser_config_file (char * const filename,
  struct audioc_args_info *args_info,
  struct audioc_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int audioc_cmdline_parser_required (struct audioc_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* AUDIOC_CMDLINE_H */
